/*
 * callbacks.h -- Function prototypes for callbacks.c
 *
 * gRustibus (c) 2000-2001 Kjetil Thuen <kjetilt@users.sourceforge.net>
 * MAME frontend for the GNOME desktop environment.
 *
 * gRustibus is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * This code is indented with GNU indent using k&r style with 8 character
 * indents as suggested by the GNOME project. Please keep it that way.
 * ($ indent -kr -ts8 -i8 *.[ch])
 *
 * Last modified: 1 April 2001 <kjetilt@users.sourceforge.net>
 *
 */

/* Widget callback functions */
void on_start_game_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_playback_game_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_record_game_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_fileselection_ok_button1_clicked(GtkButton * button,
                                    gpointer user_data);

void
 on_fileselection_cancel_button1_clicked
    (GtkButton * button, gpointer user_data);


void
on_select_random_game1_activate(GtkMenuItem * menuitem,
                                gpointer user_data);

void on_exit_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_show_correct_roms_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_show_incorect_roms_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_show_missing_roms_activate(GtkMenuItem * menuitem, gpointer user_data);

void on_show_clones_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_advanced_filters_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_configure_advanced_filter_activate(GtkMenuItem * menuitem,
                                      gpointer user_data);

void
on_screenshot_menuitem_activate(GtkMenuItem * menuitem,
                                gpointer user_data);

void
on_game_settings_menuitem_activate(GtkMenuItem * menuitem,
                                   gpointer user_data);

void
on_game_info_menuitem_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_flyer_menuitem_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_cabinet_photo_menuitem_activate(GtkMenuItem * menuitem,
                                   gpointer user_data);


void on_preferences_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_default_game_settings_activate(GtkMenuItem * menuitem,
                                  gpointer user_data);

void
on_download_selected_rom_activate(GtkMenuItem * menuitem,
                                  gpointer user_data);

void
 on_download_selected_screenshot1_activate
    (GtkMenuItem * menuitem, gpointer user_data);

void
on_download_selected_flyer_activate(GtkMenuItem * menuitem,
                                    gpointer user_data);

void
on_download_selected_cabinet_picture_activate
                                        (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void on_visit_mamedk_activate(GtkMenuItem * menuitem, gpointer user_data);


void on_about_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_visit_grustibus_homepage_activate(GtkMenuItem * menuitem,
                                     gpointer user_data);

void on_about_ok_clicked(GtkButton * button, gpointer user_data);

void
on_show_favourites_activate(GtkMenuItem * menuitem, gpointer user_data);

gboolean
on_start_game_button_release_event(GtkWidget * widget,
                                   GdkEventButton * event,
                                   gpointer user_data);

gboolean
on_preferences_button_release_event(GtkWidget * widget,
                                    GdkEventButton * event,
                                    gpointer user_data);

gboolean
on_random_button_button_release_event(GtkWidget * widget,
                                      GdkEventButton * event,
                                      gpointer user_data);

gboolean
on_quit_button_release_event(GtkWidget * widget,
                             GdkEventButton * event, gpointer user_data);

gboolean
on_game_name_list_button_release_event(GtkWidget * widget,
                                       GdkEventButton * event,
                                       gpointer user_data);

gboolean
on_rom_name_list_button_release_event(GtkWidget * widget,
                                      GdkEventButton * event,
                                      gpointer user_data);

gboolean
    on_manufacturer_list_button_release_event
    (GtkWidget * widget, GdkEventButton * event, gpointer user_data);

gboolean
on_year_list_button_release_event(GtkWidget * widget,
                                  GdkEventButton * event,
                                  gpointer user_data);

gboolean
on_button_button_release_event(GtkWidget * widget,
                               GdkEventButton * event, gpointer user_data);

void
 on_default_settings_checkbutton_toggled
    (GtkToggleButton * togglebutton, gpointer user_data);

void
on_rebuild_gamelist_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_favourite_button_toggled(GtkToggleButton * togglebutton,
                            gpointer user_data);

void
on_dga_checkbutton_toggled(GtkToggleButton * togglebutton,
                           gpointer user_data);

void
on_scanlines_checkbutton_toggled(GtkToggleButton * togglebutton,
                                 gpointer user_data);

void
on_artwork_checkbutton_toggled(GtkToggleButton * togglebutton,
                               gpointer user_data);

void
on_autoframeskip_checkbutton_toggled(GtkToggleButton * togglebutton,
                                     gpointer user_data);

void
on_colordepth_checkbutton_toggled(GtkToggleButton * togglebutton,
                                  gpointer user_data);

void
on_rotl_checkbutton_toggled(GtkToggleButton * togglebutton,
                            gpointer user_data);

void
on_rotr_checkbutton_toggled(GtkToggleButton * togglebutton,
                            gpointer user_data);

void
on_xflip_checkbutton_toggled(GtkToggleButton * togglebutton,
                             gpointer user_data);

void
on_yflip_checkbutton_toggled(GtkToggleButton * togglebutton,
                             gpointer user_data);

gboolean
on_scale_hscale_button_release_event(GtkWidget * widget,
                                     GdkEventButton * event,
                                     gpointer user_data);


void on_vectorres_option_selected(GtkMenuShell * menu_shell,
                                  gpointer user_data);

void on_vector_antialias_checkbutton_toggled
    (GtkToggleButton * togglebutton, gpointer user_data);

void on_vector_translucency_checkbutton_toggled
    (GtkToggleButton * togglebutton, gpointer user_data);

gboolean
    on_vector_beam_hscale_button_release_event
    (GtkWidget * widget, GdkEventButton * event, gpointer user_data);

gboolean
    on_vector_flicker_hscale_button_release_event
    (GtkWidget * widget, GdkEventButton * event, gpointer user_data);

void
on_sound_checkbutton_toggled(GtkToggleButton * togglebutton,
                             gpointer user_data);

void
on_samples_checkbutton_toggled(GtkToggleButton * togglebutton,
                               gpointer user_data);

void
on_fakesound_checkbutton_toggled(GtkToggleButton * togglebutton,
                                 gpointer user_data);

void on_joy_option_selected(GtkMenuShell * menu_shell, gpointer user_data);

void
on_analog_joy_checkbutton_toggled(GtkToggleButton * togglebutton,
                                  gpointer user_data);

void
on_mouse_checkbutton_toggled(GtkToggleButton * togglebutton,
                             gpointer user_data);

void
on_winkeys_checkbutton_toggled(GtkToggleButton * togglebutton,
                               gpointer user_data);

void
on_grab_mouse_checkbutton_toggled(GtkToggleButton * togglebutton,
                                  gpointer user_data);

void
on_save_settings_button_released(GtkButton * button, gpointer user_data);


void
on_game_clist_select_row(GtkCList * clist,
                         gint row,
                         gint column,
                         GdkEventButton * event, gpointer user_data);


gboolean
on_game_clist_key_release_event(GtkWidget * widget,
                                GdkEventKey * event, gpointer user_data);


gboolean
on_game_clist_focus_out_event(GtkWidget * widget,
                              GdkEventFocus * event, gpointer user_data);

gboolean
on_game_clist_focus_in_event(GtkWidget * widget,
                             GdkEventFocus * event, gpointer user_data);


void
on_gamelist_properties_popup_activate(GtkMenuItem * menuitem,
                                      gpointer user_data);

void
on_game_clist_resize_column(GtkCList * clist,
                            gint column, gint width, gpointer user_data);

void
 on_main_romlist_scrolledwindow_size_allocate
    (GtkWidget * widget, GtkAllocation * allocation, gpointer user_data);

gboolean
on_status_list_label_button_release_event(GtkWidget * widget,
                                          GdkEventButton * event,
                                          gpointer user_data);

void
on_game_clist_click_column(GtkCList * clist,
                           gint column, gpointer user_data);


gboolean
on_volume_hscale_button_release_event(GtkWidget * widget,
                                      GdkEventButton * event,
                                      gpointer user_data);


void
on_prefs_togglebutton_toggled(GtkToggleButton * togglebutton,
                              gpointer user_data);

void
on_prefs_checkbutton_toggled(GtkToggleButton * togglebutton,
                             gpointer user_data);


gboolean
on_prefs_hscale_button_release_event(GtkWidget * widget,
                                     GdkEventButton * event,
                                     gpointer user_data);


void
on_prefs_combo_entry_changed(GtkEditable * editable, gpointer user_data);

void
on_prefs_colorpicker_color_set(GnomeColorPicker * gnomecolorpicker,
                               guint arg1,
                               guint arg2,
                               guint arg3, guint arg4, gpointer user_data);

void
on_prefs_option_selected(GtkMenuShell * menu_shell, gpointer user_data);


void
on_listprefs_listfont_fontpicker_font_set(GnomeFontPicker *
                                          gnomefontpicker, GString arg1,
                                          gpointer user_data);


void
on_prefs_listfont_font_entry_activate(GtkEditable * editable,
                                      gpointer user_data);


void
 on_prefs_favouritecolor_checkbutton_toggled
    (GtkToggleButton * togglebutton, gpointer user_data);

void on_column_add_button_clicked(GtkButton * button, gpointer user_data);

void
on_column_remove_button_clicked(GtkButton * button, gpointer user_data);

void on_column_up_button_clicked(GtkButton * button, gpointer user_data);

void on_column_down_button_clicked(GtkButton * button, gpointer user_data);

void
on_available_columns_list_select_row(GtkCList * clist,
                                     gint row,
                                     gint column,
                                     GdkEvent * event, gpointer user_data);

void
on_used_columns_list_select_row(GtkCList * clist,
                                gint row,
                                gint column,
                                GdkEvent * event, gpointer user_data);


void
on_xmame_exe_combo_entry_changed(GtkEditable * editable,
                                 gpointer user_data);


void
on_rompath_combo_entry_changed(GtkEditable * editable, gpointer user_data);

void
on_prefs_window_apply(GnomePropertyBox * gnomepropertybox,
                      gint arg1, gpointer user_data);

gint on_prefs_window_close(GnomeDialog * gnomedialog, gpointer user_data);

void
on_prefs_window_help(GnomePropertyBox * gnomepropertybox,
                     gint arg1, gpointer user_data);


void
on_save_preferences_activate(GtkMenuItem * menuitem, gpointer user_data);



void
on_show_maywork_roms_activate(GtkMenuItem * menuitem, gpointer user_data);

void
on_save_window_state_activate(GtkMenuItem * menuitem, gpointer user_data);

void
 on_save_window_state_automatically_on_quit1_activate
    (GtkMenuItem * menuitem, gpointer user_data);


gboolean
on_main_window_delete_event(GtkWidget * widget,
                            GdkEvent * event, gpointer user_data);


gboolean
on_main_window_key_press_event(GtkWidget * widget,
                               GdkEventKey * event, gpointer user_data);

gboolean
on_main_window_key_release_event(GtkWidget * widget,
                                 GdkEventKey * event, gpointer user_data);


void
on_main_notebook_switch_page(GtkNotebook * notebook,
                             GtkNotebookPage * page,
                             gint page_num, gpointer user_data);
void
on_main_notebook_size_allocate(GtkWidget * widget,
                               GtkAllocation * allocation,
                               gpointer user_data);

gboolean catch_alarm(void);

void
on_cheat_checkbutton_toggled(GtkToggleButton * togglebutton,
                             gpointer user_data);


void
on_extra_options_combo_entry_changed(GtkEditable * editable,
                                     gpointer user_data);

gboolean
    on_extra_options_combo_entry_focus_in_event
    (GtkWidget * widget, GdkEventFocus * event, gpointer user_data);

gboolean
    on_extra_options_combo_entry_focus_out_event
    (GtkWidget * widget, GdkEventFocus * event, gpointer user_data);









void
 on_filter_manufacturer_checkbutton_toggled
    (GtkToggleButton * togglebutton, gpointer user_data);

void
on_filter_driver_checkbutton_toggled(GtkToggleButton * togglebutton,
                                     gpointer user_data);

void
on_filter_category_checkbutton_toggled(GtkToggleButton * togglebutton,
                                       gpointer user_data);

void
on_filter_year_checkbutton_toggled(GtkToggleButton * togglebutton,
                                   gpointer user_data);

void
on_filter_players_checkbutton_toggled(GtkToggleButton * togglebutton,
                                      gpointer user_data);

void
on_filter_controls_checkbutton_toggled(GtkToggleButton * togglebutton,
                                       gpointer user_data);

void
 on_filter_driver_status_checkbutton_toggled
    (GtkToggleButton * togglebutton, gpointer user_data);

void
on_filter_video_type_toggled(GtkToggleButton * togglebutton,
                             gpointer user_data);

void
 on_filter_screenshot_checkbutton_toggled
    (GtkToggleButton * togglebutton, gpointer user_data);

void
on_filter_flyer_checkbutton_toggled(GtkToggleButton * togglebutton,
                                    gpointer user_data);

void
on_filter_cabinet_checkbutton_toggled(GtkToggleButton * togglebutton,
                                      gpointer user_data);

void
on_filter_apply_button_clicked(GtkButton * button, gpointer user_data);

void
on_filter_cancel_button_clicked(GtkButton * button, gpointer user_data);


void
on_column_default_button_clicked(GtkButton * button, gpointer user_data);


void
on_create_report_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_report_druid_cancel                 (GnomeDruid      *gnomedruid,
                                        gpointer         user_data);

gboolean
on_report_druidpagestart_next          (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

gboolean
on_report_druidpage_filters_next       (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

gboolean
on_report_druidpage_filters_back       (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

gboolean
on_report_druidpage_columns_back       (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

gboolean
on_report_druidpage_columns_next       (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

gboolean
on_report_druidpage_format_back        (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

gboolean
on_report_druidpage_format_next        (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

gboolean
on_report_druidpagefinish_back         (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

void
on_report_druidpagefinish_finish       (GnomeDruidPage  *gnomedruidpage,
                                        gpointer         arg1,
                                        gpointer         user_data);

void
on_reportdruid_filters_cabinet_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_filters_flyer_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_filters_screenshot_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_filters_category_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_filters_driver_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_filters_manufacturer_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_filters_controls_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_filters_players_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_filters_year_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_filters_videotype_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_filters_driverstatus_checkbutton_toggled
                                        (GtkToggleButton *togglebutton,
                                        gpointer         user_data);

void
on_reportdruid_columns_available_clist_select_row
                                        (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_reportdruid_columns_selected_clist_select_row
                                        (GtkCList        *clist,
                                        gint             row,
                                        gint             column,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_reportdruid_columns_controls_down_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data);

void
on_reportdruid_columns_controls_up_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data);

void
on_reportdruid_columns_control_right_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data);

void
on_reportdruid_columns_controls_left_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data);

void
on_reportdruid_columns_controls_default_button_clicked
                                        (GtkButton       *button,
                                        gpointer         user_data);

