/*
 * fileio.h -- Function prototypes for fileio.c
 *
 * gRustibus (c) 2000-2001 Kjetil Thuen <kjetilt@users.sourceforge.net>
 * MAME frontend for the GNOME desktop environment.
 *
 * gRustibus is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * This code is indented with GNU indent using k&r style with 8 character
 * indents as suggested by the GNOME project. Please keep it that way.
 * ($ indent -kr -ts8 -i8 *.[ch])
 *
 * Last modified: 22 April 2001 <kjetilt@users.sourceforge.net>
 *
 */


#define REPORTSTYLESHEET "\
\t\t<style type=\"text/css\">\n\
\t\t\tbody {font-family: arial, helvetica, sans-serif; background: #ddeedd; color:#000000;}\n\
\t\t\th1 {font-family: arial, helvetica, sans-serif; font-size: 250%%; font-weight: bold; text-align: center;}\n\
\t\t\ttable{border-style: solid; border-color: #000000; border-width: 3px;}\n\
\t\t\ttd {border-width: 1px; border-style: solid; border-color: #000000; margin: 0px;}\n\
\t\t\tth {border-width: 1px; border-style: solid; border-color: #000000; margin: 0px;}\n\
\t\t\ttr.header {background:#94b283; color:#000000; font-weight:bold;}\n\
\t\t\ttr.even {background:#fffade; color:#000000;}\n\
\t\t\ttr.odd {background:#bedfbe; color:#000000;}\n\
\t\t\tdiv.info {background:#fffade; color:#000000; border: none; margin: 0px; padding: 10px; border-style: solid; border-color: #000000; border-width: 3px;}\n\
\t\t</style>\n"

#include <gnome.h>

void make_dir(void);
void load_prefs(void);
struct GameSettings load_game_prefs(const gchar * filename,
                                    struct GameSettings settings);
void save_xmame_version(void);
void save_prefs(void);
void save_window_prefs(void);
void save_game_prefs(const gchar * filename, struct GameSettings settings);
void load_game_settings(const gchar * game);
gboolean load_list(void);
gboolean save_list(void);
gboolean load_favourites(void);
void load_catver(void);
void load_timesplayed(void);
void save_timesplayed(void);
void save_favourites(void);
gboolean check_romdirs(void);
gboolean check_exists_dirs(gchar *dirstring);
gboolean find_image(const gchar * directories,
                    const gchar * game,
                    const gchar * cloneof, gchar ** result);
gboolean create_html_report (const GameFilter *Filter, GList *columns, const gchar *filename);
gboolean create_text_report (const GameFilter *Filter, GList *columns, const gchar *filename);
gboolean create_pretty_text_report (const GameFilter *Filter, GList *columns, const gchar *filename);
void set_timestamp (void);

// vim: ai sw=8 ts=8
